<?php

require_once 'base/GepPautapadraoEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  robertomartins
 */
class GepPautapadraoEntity extends GepPautapadraoEntityBase
{


    CONST SEM_REGISTRO = 1;


    /**
     * Gera novo codigo de Pauta Padrao.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroPautapadrao($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_PAUTAPADRAO', 10);
        return $codigo;
    }


    /**   ok
     * Consulta o maior valor de ordenacao entre os textos da pauta padrao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $tiporeuniao Numero do tipo de reuniao.
     *
     * @return multitype:|boolean
     */
    public static function consultaMaiorValorOrdenacaoPauta($nrorg, $tiporeuniao){
        $ordenacao = GepPautapadrao::consultaMaiorValorOrdenacaoPauta($nrorg, $tiporeuniao);
        return $ordenacao;
    }


    /** ok
     * Retorna dados de uma pauta padrao.
     *
     * @param integer $tipoReuniao Numero do tipo de reuniao.
     * @param integer $nrorg       Numero da organizacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaDadosPautaPadrao($tipoReuniao, $nrorg){
        $dados = GepPautapadrao::consultaPautaByTipoReuniao($tipoReuniao, $nrorg);

        if (is_array($dados) === true) {
            return $dados;
        }

        return false;
    }


    /**
    * Exclui Pauta por tipo de reuniao.
    *
    * @param integer $nrtiporeuniao Numero do tipo de reuniao.
    * @param integer $nrorg         Numero da Organizacao.
    *
    * @return boolean
    */
    public static function excluiPauta($nrtiporeuniao, $nrorg){
        $dados = GepPautapadrao::excluiPauta($nrtiporeuniao, $nrorg);
        return $dados;
    }


}