CREATE OR REPLACE
PROCEDURE EXP_REFORFIL_NGD
IS
  V_CHAVE           VARCHAR2(300);
  V_ERRO            VARCHAR2(300);
  V_CONTADOR        FLOAT := 0;
  V_VRLEADTIME      FLOAT := 0;
  V_QTMINAUTFOT     FLOAT := 0;
  V_VRLEADTIMEDESV  FLOAT := 0;
BEGIN
   FOR C_FILIALOL IN
      (SELECT CDFILIAL CDFILIOPELOG, NMFILIAL, CDREGIAO
         FROM FILIAL
        WHERE NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
          AND NVL(FILIAL.IDFUNCAOFILI, 'T') = 'O')
   LOOP
      FOR C_REFORFIL IN
         (SELECT DISTINCT C_FILIALOL.CDFILIOPELOG,  PRODFORNCOMP.CDFORNECED, PRODUTOOL.CDARVPROD, 1 IDEMPRESADEST,
                 1 QTDEORIG, 1 QTDEDEST, 1 VRLEADTIMEDESV, CASE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                              WHEN 0
                                                              THEN 1
                                                              ELSE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                           END VRARREDCMPFO,
                 NVL(FORNECEDOR.QTMINAUTFOT, 1) QTMINAUTFOT, PRODUTO.CDPRODUTO, CDPRODARVOL
            FROM PRODUTO, RELACPRODOL, PRODUTO PRODUTOOL, PRODFORNCOMP, FORNECEDOR
           WHERE ((NVL(PRODUTO.IDPRODATIVPR, 'N')   <> 'N') OR (INSTR(PRODUTO.NMPRODUTO, 'INATIVO') = 0))
             AND ((NVL(PRODUTOOL.IDPRODATIVPR, 'N') <> 'N') OR (INSTR(PRODUTOOL.NMPRODUTO, 'INATIVO') = 0))
             AND PRODUTO.CDPRODESTO IS NOT NULL
             AND PRODUTO.CDPRODUTO       = RELACPRODOL.CDPRARVORIG
             AND PRODUTOOL.CDPRODUTO     = RELACPRODOL.CDPRODARVOL
             AND PRODUTO.CDPRODUTO       = PRODFORNCOMP.CDPRODCOMPL
             AND PRODFORNCOMP.CDFORNECED = FORNECEDOR.CDFORNECED
             AND ((NVL(PRODFORNCOMP.USR_NGD_INTEGRADO, 'N') = 'N')
              OR  (NVL(FORNECEDOR.USR_NGD_INTEGRADO_1, 'N') = 'N')
              OR  (NVL(RELACPRODOL.USR_NGD_INTEGRADO_1, 'N') = 'N')
              OR  (EXISTS (SELECT 1
                             FROM PRAZOFORNEXPEDFIL
                            WHERE PRAZOFORNEXPEDFIL.CDFORNECED = FORNECEDOR.CDFORNECED
                              AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                              AND (NVL(PRAZOFORNEXPEDFIL.USR_NGD_INTEGRADO, 'N') = 'N')
                            UNION
                           SELECT 1
                             FROM MINFORNREG
                            WHERE MINFORNREG.CDFORNECED = FORNECEDOR.CDFORNECED
                              AND MINFORNREG.CDREGIAO   = C_FILIALOL.CDREGIAO
                              AND (NVL(MINFORNREG.USR_NGD_INTEGRADO, 'N') = 'N')

                          )
                  )
                 )
             AND EXISTS (SELECT 1
                           FROM ITEMCOLE
                          WHERE ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
                            AND ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
                            AND ITEMCOLE.CDPRODUTO   = RELACPRODOL.CDPRARVORIG
                            AND ITEMCOLE.DTFINVALITM >= (LAST_DAY(ADD_MONTHS(SYSDATE, -1)))))
      LOOP
         V_CONTADOR := V_CONTADOR + 1;
         IF V_CONTADOR >= 500 THEN
            V_CONTADOR := 0;
            COMMIT;
         END IF;
         SELECT MAX(QTDIASPRAZOEXPED)
           INTO V_VRLEADTIME
           FROM PRAZOFORNEXPEDFIL
          WHERE PRAZOFORNEXPEDFIL.CDFORNECED = C_REFORFIL.CDFORNECED
            AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG;
         V_VRLEADTIMEDESV := 1;
         IF V_VRLEADTIME IS NULL THEN
            V_VRLEADTIME     := 1;
            V_VRLEADTIMEDESV := 1;
         ELSIF V_VRLEADTIME = 0 THEN
            V_VRLEADTIME     := 1;
            V_VRLEADTIMEDESV := 1;
         ELSE
            V_VRLEADTIMEDESV := CEIL(V_VRLEADTIME * 0.2);
         END IF;

         SELECT NVL(MAX(QTMINFORNREG), C_REFORFIL.QTMINAUTFOT)
           INTO V_QTMINAUTFOT
           FROM MINFORNREG
          WHERE CDFORNECED = C_REFORFIL.CDFORNECED
            AND CDREGIAO   = C_FILIALOL.CDREGIAO;
         IF V_QTMINAUTFOT = 0 THEN
            V_QTMINAUTFOT := 0;
         END IF;

         SELECT NVL(MAX(USR_REFORFIL_NGD.CDFILIOPELOG), '')
           INTO V_CHAVE
           FROM USR_REFORFIL_NGD
          WHERE USR_REFORFIL_NGD.CDFILIOPELOG = C_FILIALOL.CDFILIOPELOG
            AND USR_REFORFIL_NGD.CDFORNECED   = C_REFORFIL.CDFORNECED
            AND USR_REFORFIL_NGD.CDARVPROD    = C_REFORFIL.CDARVPROD;
         BEGIN
            IF V_CHAVE = '' THEN
               INSERT
                INTO USR_REFORFIL_NGD(CDFILIOPELOG, CDFORNECED, CDARVPROD, IDEMPRESADEST,
                                      QTDEORIG, QTDEDEST, VRLEADTIME, VRLEADTIMEDESV,
                                      QTMINAUTFOT, VRARREDCMPFO, IDSTATUSFORFIL,
                                      TPINTERFACE, DTINTERFACEORI,	DTINTERFACEDEST,	STATUS)
               VALUES (C_FILIALOL.CDFILIOPELOG, C_REFORFIL.CDFORNECED, C_REFORFIL.CDARVPROD, C_REFORFIL.IDEMPRESADEST,
                       C_REFORFIL.QTDEORIG, C_REFORFIL.QTDEDEST, V_VRLEADTIME, V_VRLEADTIMEDESV,
                       V_QTMINAUTFOT, C_REFORFIL.VRARREDCMPFO, 'ATIVO',	'I', 	SYSDATE,	NULL,	'1');
            ELSE
               UPDATE USR_REFORFIL_NGD
                  SET VRLEADTIME         = V_VRLEADTIME,
                      VRLEADTIMEDESV     = V_VRLEADTIMEDESV,
                      QTMINAUTFOT        = V_QTMINAUTFOT,
                      VRARREDCMPFO       = C_REFORFIL.VRARREDCMPFO,
                      TPINTERFACE        = 'A',
                      DTINTERFACEORI     = SYSDATE,
                      DTINTERFACEDEST    = NULL,
                      STATUS             = '1'
                WHERE USR_REFORFIL_NGD.CDFILIOPELOG = C_FILIALOL.CDFILIOPELOG
                  AND USR_REFORFIL_NGD.CDFORNECED   = C_REFORFIL.CDFORNECED
                  AND USR_REFORFIL_NGD.CDARVPROD    = C_REFORFIL.CDARVPROD;
            END IF;
            UPDATE USR_LOG_NGD
               SET DTLOG      = SYSDATE,
                   STATUS     = '0',
                   OBSSTATUS  = NULL
             WHERE IDPROCESSO = 'USR_REFORFIL_NGD'
               AND IDPESQITEM = C_REFORFIL.CDFILIOPELOG||'-'||C_REFORFIL.CDFORNECED||'-'||C_REFORFIL.CDARVPROD;
            IF SQL%NOTFOUND THEN
              INSERT
                INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
              VALUES ('USR_REFORFIL_NGD', SYSDATE, '0', NULL, C_REFORFIL.CDFILIOPELOG||'-'||C_REFORFIL.CDFORNECED||'-'||C_REFORFIL.CDARVPROD);
            END IF;
         EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
               UPDATE USR_LOG_NGD
                  SET DTLOG      = SYSDATE,
                      STATUS     = '1',
                      OBSSTATUS  = V_ERRO
                WHERE IDPROCESSO = 'USR_REFORFIL_NGD'
                  AND IDPESQITEM = C_REFORFIL.CDFILIOPELOG||'-'||C_REFORFIL.CDFORNECED||'-'||C_REFORFIL.CDARVPROD;
               IF SQL%NOTFOUND THEN
                  INSERT
                    INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                  VALUES ('USR_REFORFIL_NGD', SYSDATE, '1', V_ERRO, C_REFORFIL.CDFILIOPELOG||'-'||C_REFORFIL.CDFORNECED||'-'||C_REFORFIL.CDARVPROD);
               END IF;
            END;
         END;
      END LOOP;
   END LOOP;

   /*ATUALIZA REGISTROS PARA NO SEREM INTEGRADOS NOVAMENTE*/
   FOR C_REFORFIL IN
      (SELECT  DISTINCT  PRODFORNCOMP.CDFORNECED, PRODUTOOL.CDARVPROD, 1 IDEMPRESADEST,
              1 QTDEORIG, 1 QTDEDEST, 1 VRLEADTIMEDESV, CASE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                           WHEN 0
                                                           THEN 1
                                                           ELSE NVL(PRODFORNCOMP.VRARREDCMPFO, 0)
                                                        END VRARREDCMPFO,
              NVL(FORNECEDOR.QTMINAUTFOT, 1) QTMINAUTFOT, PRODUTO.CDPRODUTO, CDPRODARVOL
         FROM PRODUTO, RELACPRODOL, PRODUTO PRODUTOOL, PRODFORNCOMP, FORNECEDOR
        WHERE ((NVL(PRODUTO.IDPRODATIVPR, 'N')   <> 'N') OR (INSTR(PRODUTO.NMPRODUTO, 'INATIVO') = 0))
          AND ((NVL(PRODUTOOL.IDPRODATIVPR, 'N') <> 'N') OR (INSTR(PRODUTOOL.NMPRODUTO, 'INATIVO') = 0))
          AND PRODUTO.CDPRODESTO IS NOT NULL
          AND PRODUTO.CDPRODUTO       = RELACPRODOL.CDPRARVORIG
          AND PRODUTOOL.CDPRODUTO     = RELACPRODOL.CDPRODARVOL
          AND PRODUTO.CDPRODUTO       = PRODFORNCOMP.CDPRODCOMPL
          AND PRODFORNCOMP.CDFORNECED = FORNECEDOR.CDFORNECED
          AND ((NVL(PRODFORNCOMP.USR_NGD_INTEGRADO, 'N') = 'N')
           OR  (NVL(FORNECEDOR.USR_NGD_INTEGRADO_1, 'N') = 'N')
           OR  (NVL(RELACPRODOL.USR_NGD_INTEGRADO_1, 'N') = 'N')
           OR  (EXISTS (SELECT 1
                          FROM PRAZOFORNEXPEDFIL
                         WHERE PRAZOFORNEXPEDFIL.CDFORNECED = FORNECEDOR.CDFORNECED
                           --AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
                           AND (NVL(PRAZOFORNEXPEDFIL.USR_NGD_INTEGRADO, 'N') = 'N')
                         UNION
                        SELECT 1
                          FROM MINFORNREG
                         WHERE MINFORNREG.CDFORNECED = FORNECEDOR.CDFORNECED
                           --AND MINFORNREG.CDREGIAO   = C_FILIALOL.CDREGIAO
                           AND (NVL(MINFORNREG.USR_NGD_INTEGRADO, 'N') = 'N')

                       )
               )
              )
          AND EXISTS (SELECT 1
                        FROM ITEMCOLE
                       WHERE /*ITEMCOLE.CDREGIAO    = C_FILIALOL.CDREGIAO
                         AND */ITEMCOLE.CDFORNECED  = FORNECEDOR.CDFORNECED
                         AND ITEMCOLE.CDPRODUTO   = RELACPRODOL.CDPRARVORIG
                         AND ITEMCOLE.DTFINVALITM >= (LAST_DAY(ADD_MONTHS(SYSDATE, -1)))))
   LOOP
      V_CONTADOR := V_CONTADOR + 1;
      IF V_CONTADOR >= 500 THEN
         V_CONTADOR := 0;
         COMMIT;
      END IF;
      UPDATE PRAZOFORNEXPEDFIL
         SET USR_NGD_INTEGRADO = 'S'
       WHERE PRAZOFORNEXPEDFIL.CDFORNECED = C_REFORFIL.CDFORNECED
       --  AND PRAZOFORNEXPEDFIL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
         AND NVL(USR_NGD_INTEGRADO, 'N')  = 'N';
      UPDATE MINFORNREG
         SET USR_NGD_INTEGRADO = 'S'
       WHERE MINFORNREG.CDFORNECED       = C_REFORFIL.CDFORNECED
         --AND MINFORNREG.CDREGIAO         = C_FILIALOL.CDREGIAO
         AND NVL(USR_NGD_INTEGRADO, 'N') = 'N';
      UPDATE PRODFORNCOMP
         SET USR_NGD_INTEGRADO = 'S'
       WHERE PRODFORNCOMP.CDFORNECED       = C_REFORFIL.CDFORNECED
         AND PRODFORNCOMP.CDPRODCOMPL      = C_REFORFIL.CDPRODUTO
         AND NVL(USR_NGD_INTEGRADO, 'N') = 'N';
      UPDATE FORNECEDOR
         SET USR_NGD_INTEGRADO_1 = 'S'
       WHERE FORNECEDOR.CDFORNECED       = C_REFORFIL.CDFORNECED
         AND NVL(USR_NGD_INTEGRADO_1, 'N') = 'N';
      UPDATE RELACPRODOL
         SET USR_NGD_INTEGRADO_1 = 'S'
       WHERE RELACPRODOL.CDPRODARVOL       = C_REFORFIL.CDPRODARVOL
         AND NVL(USR_NGD_INTEGRADO_1, 'N') = 'N';
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXP_REFORFIL_NGD','6.37.018'); END;
/
