/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERC                                                     */
/* Tabela : SERVCONTRAT                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SERC
BEFORE INSERT OR UPDATE OR DELETE
ON SERVCONTRAT FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSERC := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUSERC := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SERVCONTRAT', '', 'CDCLIENTE='||:OLD.CDCLIENTE||';CDSERVCONT='||:OLD.CDSERVCONT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SERVCONTRAT MODIFY DTULTATUSERC DEFAULT SYSDATE
/
